#!/usr/bin/perl

use strict;
use warnings;

use CGI;
use LWP::UserAgent;
use URI::Escape;
use HTML::Entities;

#
# I need the following parameters
# to learn a message as spam:
#
# action
# User.context
# Item.drn (can be multiple, for multiple messages)
#
# I access the following WebAccess template to get some additional
# parameters
#
# spambtn_fldrlist
#

# configure these:
my $BASEURL = "http://localhost/gw/webacc";
my $SENDMAIL = "/usr/sbin/sendmail";
my $LEARNSPAMADDR = 'learnspam@messiah.edu';
my $UNLEARNSPAMADDR = 'learnham@messiah.edu';
my $DOMAIN = "messiah.edu";
my $SENDERADDR = 'learnspam-webaccess@messiah.edu';
my $IMAGESURL = "/webaccess/200905172308/js";
my $NOBODY = 'nobody@messiah.edu';


my $CGI = CGI->new;
my $W = "";
$SIG{__WARN__} = sub { $W .= shift };
$SIG{__DIE__} = sub {
	print $CGI->header(
		-status => 500,
		-type => "text/plain");
	print $W;
	print shift;
	exit 1;
};

my $ua = LWP::UserAgent->new(
	agent => $ENV{HTTP_USER_AGENT});

my $action = $CGI->param("action") || "LEARNSPAM";
my $context = $CGI->param("User.context")
	or die "Error: User.context unknown\n";

# First, access the "spambtn_fldrlist" page, to determine the folder
# ids of the "Mailbox" and "Junk Mail" folders, as well as the username
# of the currently logged in user.
my ($user, $mailbox_id, $junk_id) = fetch_fldrlist_page($context);

foreach my $drn ($CGI->param("Item.drn"))
{
	my $url = $BASEURL . "?action=Item.Read"
		. "&User.context=" . uri_escape($context)
		. "&Item.drn=" . uri_escape($drn)
		. "&merge=msgitem"
		. "&Url.Folder.type=Folder.UNIVERSAL";
	my $req = HTTP::Request->new(GET => $url);
	$req->header("Cookie", $ENV{HTTP_COOKIE});
	my $r = $ua->request($req);
	unless ($r->is_success)
	{
		die "error getting message: " . $r->status_line . "\n";
	}

	my $content = $r->content;
	unless ($content =~ m#<div id="idHeaderBody"#)
	{
		die "Internal error (the CGI script cannot access the message)\n";
	}

	unless ($content =~ m#<span id="attachment_filename_(\d+)">Mime\.822</span>#)
	{
		# This is not an Internet message, so it cannot be marked as Spam.
		# (no Mime.822 attachment)
		next;
	}

	my $attachidx = $1;
	$url = $BASEURL . "?action=Attachment.Save"
		. "&Item.Attachment.id=" . uri_escape($attachidx)
		. "&User.context=" . uri_escape($context)
		. "&Item.drn=" . uri_escape($drn)
		. "&Item.Child.id=";
	$req = HTTP::Request->new(GET => $url);
	$req->header("Cookie", $ENV{HTTP_COOKIE});
	$r = $ua->request($req);
	unless ($r->is_success)
	{
		die "error getting attachment: " . $r->status_line . "\n";
	}

	my $addr = $action eq "LEARNHAM" ? $UNLEARNSPAMADDR : $LEARNSPAMADDR;
	open SENDMAIL, "|-", "$SENDMAIL -i -f $SENDERADDR $addr"
		or die "Error: cannot run sendmail: $!\n";
	print SENDMAIL "From: $user <$user\@$DOMAIN>\n";
	print SENDMAIL "Sender: $SENDERADDR\n";
	print SENDMAIL "To: $LEARNSPAMADDR\n";
	print SENDMAIL "Reply-To: $NOBODY\n";
	print SENDMAIL "Subject: $action ($user, $mailbox_id, $junk_id)\n";
	print SENDMAIL "Mime-Version: 1.0\n";
	print SENDMAIL "Content-Type: message/rfc822\n";
	print SENDMAIL "\n";
	print SENDMAIL $r->content;
	close SENDMAIL;
}

print $CGI->header;
print qq|
<html>
<head>
<script src="$IMAGESURL/webacc.js" language="javascript" type="text/javascript"></script>
</head>
<body>
<script language="javascript">|;
my $next_url = $CGI->param("next");
if ($next_url)
{
	$next_url =~ s/JUNKMAIL/$junk_id/;
	$next_url =~ s/MAILBOX/$mailbox_id/;

	print qq|
var nextUrl = "$next_url";
window.location.href = nextUrl;|;
}
print qq|
</script>
</body>
</html>
|;

sub fetch_fldrlist_page
{
	my ($context) = @_;
	my $url = $BASEURL . "?action=Folder.List.Open"
		. "&User.context=" . uri_escape($context)
		. "&merge=spambtn_fldrlist";
	my $req = HTTP::Request->new(GET => $url);
	$req->header("Cookie", $ENV{HTTP_COOKIE});
	my $r = $ua->request($req);
	unless ($r->is_success)
	{
		die "error getting message: " . $r->status_line . "\n";
	}

	my $content = $r->content;
	unless ($content =~ m#<body id="spambtn_fldrlist_body"#)
	{
		die "Internal authentication error (the CGI script cannot access the WebAccess session)\n";
	}

	my ($userid, $mailbox_id, $junk_id);
	if ($content =~ m#<div id="userid">(.*?)</div>#)
	{
		$userid = $1;
	}
	if ($content =~ m#<td id="folder_(\d+)_type">Folder.UNIVERSAL</td>#)
	{
		$mailbox_id = $1;
	}
	if ($content =~ m#<td id="folder_(\d+)_type">Folder.JUNKMAIL</td>#)
	{
		$junk_id = $1;
	}
	return ($userid, $mailbox_id, $junk_id);
}
